#! /usr/local/bin/perl5
print "Content-type: text/html\n\n";

########################################################################
#   f܂ł̋						       #
########################################################################
#   Tu[`
#
# planet			ff[^쐬
# point3d			3Wf[^쐬
# distance			f[^쐬
# getData			f[^ǂݍ
# writeTime			\
# writeJday			EX\
# jdTime			EXɕϊ
# writeNowTime			ݎ\
# perturbation			(ۓ (2000N) vZjgp
# kepler			Pv[
# distance3D			RQ_ԋvZ
# calcPlanetCoord		f̈ʒuvZ
# fromEarthDistance		n|fԋvZ
# writeDistance			f܂ł̋\
# writeDistanceFromEarth	\ (n)
# writeDistanceFromSun		\ (z)
# showHTML			HTML t@Cĕ\
# err				G[bZ[W\
########################################################################

########################################################################
# include
use CGI;

########################################################################
# global variables
my $query=new CGI;

# HTML ev[g
my $template='planetCGI.html';

# f[^
my $dataFile='planet.dat';

# tolerance
my $tol=1.0E-8;

# EXۂߌ덷
my $round_jd=1.0E-5;

# VPʋۂߌ덷
my $round_au=1.0E-4;

# kmۂߌ덷
my $round_km=1;

# ~
my $pi=4*atan2(1,1);

#  -> WA
my $rad=$pi/180;

# 1 AU = 1.4959787E8 km
my $aukm=1.4959787E8;

# ݂̃EX
my $jd=time()/86400+2440587.5;

# _̃EX
my $baseJd=2451545.0;

# f̖O ({)
my @namej=('','','n','ΐ','ؐ','y','V',
      	   'C','');

# ff[^
my @planets=();

# z̋
my @lens=();

# n̋
my @lene=();

########################################################################
# Tu[`
########################################################################

########################################################################
# ff[^쐬
# p[^F
# {ꖼEpꖼEOaESEߓ_oE_oE
# OXΊpEωoEpx
sub planet($$$$$$$$$){
  my ($namej,$namee,$sma,$eccen,$lofp,$lofan,$inc,$meanl,$angVel)=@_;
  my $pl={namej=>$namej,namee=>$namee,sma=>$sma,eccen=>$eccen,
      	  lofp=>$lofp,lofan=>$lofan,inc=>$inc,meanl=>$meanl,
      	  angVel=>$angVel};
  return $pl;
}

########################################################################
# 3Wf[^쐬
sub point3d($$$){
  my ($x,$y,$z)=@_;
  my $p={x=>$x,y=>$y,z=>$z};
  return $p;
}

########################################################################
# f[^쐬
sub distance($$){
  my ($au,$km)=@_;
  my $d={au=>$au,km=>$km};
  return $d;
}

########################################################################
# f[^ǂݍ
sub getData{

  open DATA, $dataFile or err("$dataFileJ܂");
  flock(DATA,1);

  my $line=0;
  while(<DATA>){
    chop;
    $line++;
    if($line==1){
      my ($dummy1,$dummy2,$dummy3,$epoch)=split /\s+/, $_;
      $baseJd=$epoch;
    }
    elsif($line>3){
      my ($name,$rgb,$vr,$sma0,$eccen0,$lofp0,$lofan0,$inc0,
      	  $meanl0,$period)=split /\s+/, $_;
      push @planets,planet($namej[$line-4],$name,$sma0,$eccen0,
      	      	      	   $rad*$lofp0,$rad*$lofan0,$rad*$inc0,
      	      	      	   $rad*$meanl0,2.0*$pi/(365.25*$period));
    }
  }
  close DATA;
}

########################################################################
# \
sub writeTime($$$$$$){
  my ($year,$mon,$day,$hour,$min,$sec)=@_;

  print "        <td align=\"right\">",
      	" $yearN $mon $day $hour $min $secb</td>\n";
}

########################################################################
# EX\
sub writeJday($){
  my $jd=$_[0];

  my $jdout=int($jd/$round_jd)*$round_jd;
  print "        <td align=\"right\"> $jdout</td>\n";
}

########################################################################
# EXɕϊ
sub jdTime($){
  my $jd=$_[0];

  my $aa=int($jd+68569.5);
  my $bb=int($aa/36524.25);
  my $cc=$aa-int(36524.25*$bb+0.75);
  my $ee=int(($cc+1)/365.25025);
  my $ff=$cc-int(365.25*$ee)+31;
  my $gg=int($ff/30.59);
  my $hh=int($gg/11);
  my $ii=$jd+0.5-int($jd+0.5);
  my $year=100*($bb-49)+$ee+$hh;
  my $mon=$gg-12*$hh+2;
  my $day=$ff-int(30.59*$gg);
  my $hour=int(24*$ii);
  my $min=int(1440*($ii-$hour/24));
  my $sec=int(86400*($ii-$hour/24-$min/1440));
  ($year,$mon,$day,$hour,$min,$sec);
}

########################################################################
# ݎ\
sub writeNowTime{
  my $jdj=$jd+0.375;		# {
  my $mjd=$jd-2400000.5;	# EX
  my ($jyear,$jmon,$jday,$jhour,$jmin,$jsec)=jdTime($jdj);
  my ($year,$mon,$day,$hour,$min,$sec)=jdTime($jd);
  print "      <tr>\n",
      	"        <td align=\"left\">{ (JST)</td>\n";
  writeTime($jyear,$jmon,$jday,$jhour,$jmin,$jsec);
  print "      </tr>\n      <tr>\n",
      	"        <td align=\"left\">OjbWW (GMT)</td>\n";
  writeTime($year,$mon,$day,$hour,$min,$sec);
  print "      </tr>\n      <tr>\n",
      	"        <td align=\"left\">EX (JD)</td>\n";
  writeJday($jd);
  print "      </tr>\n      <tr>\n",
      	"        <td align=\"left\">EX (MJD)</td>\n";
  writeJday($mjd);
  print "      </tr>\n";
}

########################################################################
# ۓ (2000N) vZ
sub perturbation($){
  my $jd=$_[0];

  my $tp=($jd-$baseJd)/36525;
  my $tp2=$tp*$tp;

# 
  $planets[0]->{meanl}=252.2509+0.0003*$tp2;
  $planets[0]->{lofp}=77.4561+1.5564*$tp+0.0003*$tp2;
  $planets[0]->{lofan}=48.3309+1.1861*$tp+0.0002*$tp2;
  $planets[0]->{inc}=7.0050+0.0018*$tp;
  $planets[0]->{eccen}=0.205632+0.00002*$tp;

# 
  $planets[1]->{meanl}=181.9798+0.0003*$tp2;
  $planets[1]->{lofp}=131.5637+1.4022*$tp-0.0011*$tp2;
  $planets[1]->{lofan}=76.6799+0.9010*$tp+0.0004*$tp2;
  $planets[1]->{inc}=3.3947+0.0010*$tp;
  $planets[1]->{eccen}=0.006772-0.000048*$tp;

# n
  $planets[2]->{meanl}=100.4664+0.0003*$tp2;
  $planets[2]->{lofp}=102.9373+1.719597*$tp+0.0005*$tp2;
  $planets[2]->{eccen}=0.016709-0.000042*$tp;

# ΐ
  $planets[3]->{meanl}=355.4330+0.0003*$tp2;
  $planets[3]->{lofp}=336.0602+1.8410*$tp+0.0001*$tp2;
  $planets[3]->{lofan}=49.5581+0.7720*$tp;
  $planets[3]->{inc}=1.8497-0.0006*$tp;
  $planets[3]->{eccen}=0.093401+0.00009*$tp;

# ؐ
  $planets[4]->{meanl}=34.3515+0.0002*$tp2;
  $planets[4]->{lofp}=14.3312+1.6126*$tp+0.0010*$tp2;
  $planets[4]->{lofan}=100.4644+1.0210*$tp+0.0004*$tp2;
  $planets[4]->{inc}=1.3033-0.0055*$tp;
  $planets[4]->{eccen}=0.048498+0.000163*$tp;

# y
  $planets[5]->{meanl}=50.0774+0.0005*$tp2;
  $planets[5]->{lofp}=93.0572+1.9638*$tp+0.0008*$tp2;
  $planets[5]->{lofan}=113.6655+0.8771*$tp-0.0001*$tp2;
  $planets[5]->{inc}=2.4889-0.0037*$tp;
  $planets[5]->{eccen}=0.055548-0.000347*$tp;
  $planets[5]->{sma}=9.554909-0.000002*$tp;

# V
  $planets[6]->{meanl}=314.0550+0.0003*$tp2;
  $planets[6]->{lofp}=173.0052+1.4863*$tp+0.0002*$tp2;
  $planets[6]->{lofan}=74.0060+0.5211*$tp+0.0013*$tp2;
  $planets[6]->{inc}=0.7732+0.0008*$tp;
  $planets[6]->{eccen}=0.046381-0.000027*$tp;

# C
  $planets[7]->{meanl}=304.3487+0.0003*$tp2;
  $planets[7]->{lofp}=48.1203+1.4263*$tp+0.0004*$tp2;
  $planets[7]->{lofan}=131.7841+1.1022*$tp+0.0003*$tp2;
  $planets[7]->{inc}=1.7700-0.0093*$tp;
  $planets[7]->{eccen}=0.009456+0.000006*$tp;

# 
  $planets[8]->{meanl}=238.4670-0.0091*$tp2;
  $planets[8]->{lofp}=224.1416+1.3901*$tp+0.0003*$tp2;
  $planets[8]->{lofan}=110.3182+1.3507*$tp+0.0004*$tp2;
  $planets[8]->{inc}=17.1451-0.0055*$tp;
  $planets[8]->{eccen}=0.249005+0.000039*$tp;
  $planets[8]->{sma}=39.540343+0.003131*$tp;
}

########################################################################
# Pv[
sub kepler($$){
  my ($m,$e)=@_;

  my $ei=$m+$e*sin($m);
  my $mi=$ei-$e*sin($ei);
  my $dm=abs($m-$mi);
  while($dm>$tol){
    $ei=$ei+($m-$mi)/(1-$e*cos($ei));
    $mi=$ei-$e*sin($ei);
    $dm=abs($m-$mi);
  }
  $ei;
}

########################################################################
# RQ_ԋvZ
sub distance3D($$){
  my ($p1,$p2)=@_;

  my $dx=$p2->{x}-$p1->{x};
  my $dy=$p2->{y}-$p1->{y};
  my $dz=$p2->{z}-$p1->{z};
  my $dist=sqrt($dx*$dx+$dy*$dy+$dz*$dz);
  $dist;
}

########################################################################
# f̈ʒuvZ
sub calcPlanetCoord($$$$$$$$){
  my ($day,$sma,$eccen,$lofp,$lofan,$inc,$meanl,$angVel)=@_;

  my $m=$meanl-$lofp+$angVel*$day;
  my $eeh=0.5*kepler($m,$eccen);
  my $v=$pi;
  if(cos($eeh)!=0){
    my $tanv=sqrt((1+$eccen)/(1-$eccen))*sin($eeh);
    $v=2*atan2($tanv,cos($eeh));
  }
  my $rr=$sma*(1-$eccen*cos(2*$eeh));
  my $x1=$rr*cos($v+$lofp);
  my $y1=$rr*sin($v+$lofp);
  my $x2=$x1*cos($lofan)+$y1*sin($lofan);
  my $y2=-$x1*sin($lofan)+$y1*cos($lofan);
  my $y3=$y2*cos($inc);
  my $zz=$y2*sin($inc);
  my $xx=$x2*cos($lofan)-$y3*sin($lofan);
  my $yy=$x2*sin($lofan)+$y3*cos($lofan);
  (point3d($xx,$yy,$zz),$rr);
}

########################################################################
# n|fԋvZ
sub fromEarthDistance(){

  my @p=();	# f3W
  my $jday2=$jd-$baseJd;

  for(my $i=0;$i<8;$i++){
    my $pl=$planets[$i];
    my ($p0,$d)=calcPlanetCoord($jday2,$pl->{sma},$pl->{eccen},
      	      	      	      	$pl->{lofp},$pl->{lofan},$pl->{inc},
      	      	      	      	$pl->{meanl},$pl->{angVel});
    push @p,$p0;
    push @lens,distance($d,$aukm*$d);
  }
  for(my $i=0;$i<8;$i++){
    if($i==2){
      push @lene,distance(0,0);
    }
    else{
      my $d=distance3D($p[$i],$p[2]);
      push @lene,distance($d,$aukm*$d)
    }
  }
}

########################################################################
# f܂ł̋\
sub writeDistance($$){
  my ($pl,$len)=@_;

  my $lenau=int($len->{au}/$round_au)*$round_au;
  my $lenkm=int($len->{km}/$round_km)*$round_km;
  print "      <tr>\n",
      	"        <td align=\"left\">$pl->{namej} ($pl->{namee}) ",
      	"܂</td>\n",
      	"        <td align=\"right\"> $lenau (AU)</td>\n",
      	"        <td align=\"right\"> $lenkm (km)</td>\n",
      	"      </tr>\n";
}

########################################################################
# \ (n)
sub writeDistanceFromEarth{
  for(my $i=0;$i<8;$i++){
    if($i!=2){
      writeDistance($planets[$i],$lene[$i]);
    }
  }
}

########################################################################
# \ (z)
sub writeDistanceFromSun{
  for(my $i=0;$i<8;$i++){
    writeDistance($planets[$i],$lens[$i]);
  }
}

########################################################################
# HTML t@Cĕ\
sub showHTML{

  open HTML,$template or err("$templateJ܂");
  flock(HTML,1);
  my @html=<HTML>;
  close HTML;

  foreach(@html){
    if(s/<CGI:date>//i){
      writeNowTime();
    }
    elsif(s/<CGI:earth>//i){
      writeDistanceFromEarth();
    }
    elsif(s/<CGI:sun>//i){
      writeDistanceFromSun();
    }
    else{
      print;
    }
  }
}

########################################################################
# G[bZ[W\
sub err{
  print "<html>\n",
      	"  <head></head>\n",
      	"  <body>\n";
  print $_[0];
  print "\n  </body>\n",
      	"</html>\n";
  exit();
}

########################################################################
# C[`

getData();
#perturbation($jd);  # ۓ͖gp
fromEarthDistance();

showHTML();

exit();
