package planet;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;

//--------------------------------------------------------------------//
/**
 * fXg
 */
public class PlanetList implements Cloneable{

/**
 * f[^Xg<br>
 *  <code>ArrayList</code> ɈϏ
 */
  private ArrayList list;

/**
 * fXg\z
 */
  public PlanetList(){
    list=new ArrayList();
  }

//--------------------------------------------------------------------//
/**
 * f̐Ԃ
 * @return f̐
 */
  public int getSize(){
    return list.size();
  }

//--------------------------------------------------------------------//
/**
 * fԂ
 * @param index f̃CfbNX
 * @return w肳ꂽʒu̘f
 */
  public Planet get(int index){
    try{
      return (Planet)list.get(index);
    }
    catch(Exception ex){
      return null;
    }
  }

//--------------------------------------------------------------------//
/**
 * fǉ
 * @param planet ǉf
 */
  public void add(Planet planet){
    list.add(planet);
  }

//--------------------------------------------------------------------//
/**
 * fǉ
 * @param index fǉCfbNX
 * @param planet ǉf
 */
  public void add(int index,Planet planet){
    list.add(index,planet);
  }

//--------------------------------------------------------------------//
/**
 * fu
 * @param index fuCfbNX
 * @param planet uf
 */
  public void set(int index,Planet planet){
    list.set(index,planet);
  }

//--------------------------------------------------------------------//
/**
 * f폜
 * @param index f폜CfbNX
 * @return 폜ꂽf
 */
  public Planet remove(int index){
    try{
      return (Planet)list.remove(index);
    }
    catch(Exception ex){
      return null;
    }
  }

//--------------------------------------------------------------------//
/**
 * f[^
 */
  public void clear(){
    list.clear();
  }

//--------------------------------------------------------------------//
/**
 * f̃CfbNX
 * @param planet CfbNXf
 * @return w肳ꂽfŏɌCfbNX<br>
 *         f݂Ȃꍇ -1 Ԃ
 */
  public int indexOf(Planet planet){
    return list.indexOf(planet);
  }

//--------------------------------------------------------------------//
/**
 * z̃TCYŏɂ
 */
  public void trimToSize(){
    list.trimToSize();
  }

//--------------------------------------------------------------------//
/**
 * Xgבւ
 * @param comparator rIuWFNg
 */
  public void sort(Comparator comparator){
    Collections.sort(list,comparator);
  }

//--------------------------------------------------------------------//
/**
 * XgŎw肵fɗאڂfԂ
 * @param oldPlanet Xgɂf
 * @param comparator rIuWFNg
 * @param displacement w肳ꂽf̃XgCfbNXړ
 * @return w肳ꂽfɗאڂf
 */
  public Planet neighbourPlanet(Planet oldPlanet,Comparator comparator,
      	      	      	      	int displacement){
    sort(comparator);
    return neighbourPlanet(oldPlanet,displacement);
  }

//--------------------------------------------------------------------//
/**
 * XgŎw肵fɗאڂfԂ
 * @param oldPlanet Xgɂf
 * @param displacement w肳ꂽf̃XgCfbNXړ
 * @return w肳ꂽfɗאڂf
 */
  public Planet neighbourPlanet(Planet oldPlanet,int displacement){
    int index=list.indexOf(oldPlanet);
    int size=getSize();
    if((index<0) || (size==0)) return null;
    index+=displacement;
    while(index<0) index+=size;
    index%=size;
    return get(index);
  }

//--------------------------------------------------------------------//
/**
 * IuWFNg̃Rs[Ԃ
 * @return ̃CX^X̕
 */
  public Object clone(){
    try{
      PlanetList planetList=(PlanetList)super.clone();
      planetList.list=new ArrayList();
      int size=getSize();
      for(int j=0;j<size;j++){
      	planetList.list.add(get(j).clone());
      }
      return planetList;
    }
    catch(CloneNotSupportedException ex){
      throw new InternalError();
    }
  }

//--------------------------------------------------------------------//
/**
 * IuWFNg̃nbVR[hlԂ
 * @return IuWFNg̃nbVR[hl
 */
  public int hashCode(){
    return list.hashCode();
  }

//--------------------------------------------------------------------//
/**
 * IuWFNg̓
 * @param obj rΏۂ̃IuWFNg
 * @return rΏۂ̃IuWFNg <code>PlanetList</code>
 *         ̃CX^Xœlꍇ true
 */
  public boolean equals(Object obj){
    if(obj instanceof PlanetList){
      PlanetList planetList=(PlanetList)obj;
      return list.equals(planetList.list);
    }
    return false;
  }
}
