package planet.action;
import java.util.Comparator;
import planet.Planet;
import planet.PlanetList;
import planet.PlanetOrbitComparator;
import planet.PlanetViewCanvas;

//--------------------------------------------------------------------//
/**
 * f|C^ړANV
 */
public class MovePointerAction implements SimpleAction{

/** f̋Oa̔rIuWFNg */
  protected static final Comparator
    ORBIT_COMPARATOR=new PlanetOrbitComparator();

/** \LoX */
  protected PlanetViewCanvas canvas;

/** |C^̃CfbNX */
  protected int index;

/** |C^Ŏw肳ꂽf̃XgCfbNXړ */
  protected int displacement;

/**
 * f|C^ړANV\z
 * @param canvas \LoX
 * @param index |C^̃CfbNX
 * @param displacement |C^Ŏw肳ꂽf̃XgCfbNXړ
 */
  public MovePointerAction(PlanetViewCanvas canvas,int index,
      	      	      	   int displacement){
    this.canvas=canvas;
    this.index=index;
    this.displacement=displacement;
  }

//--------------------------------------------------------------------//
/**
 * f|C^ړ
 */
  public void doAction(){
    PlanetList pointer=canvas.getPointer();
    PlanetList list=canvas.getModel().getList();
    Planet nextPlanet=list.neighbourPlanet
      (pointer.get(index),ORBIT_COMPARATOR,displacement);
    pointer.set(index,nextPlanet);
    canvas.repaint();
  }
}
