package planet.action;
import planet.Planet;
import planet.PlanetViewCanvas;

//--------------------------------------------------------------------//
/**
 * \[hIANV
 */
public class ViewModeAction implements SimpleAction{

/** \LoX */
  protected PlanetViewCanvas canvas;

/**
 * \[hIANV\z
 * @param canvas \LoX
 */
  public ViewModeAction(PlanetViewCanvas canvas){
    this.canvas=canvas;
  }

//--------------------------------------------------------------------//
/**
 * \[hI
 */
  public void doAction(){
    switch(canvas.getViewMode()){
      case Planet.INNER_PLANET:
      	canvas.setViewMode(Planet.OUTER_PLANET);
      	break;
      case Planet.OUTER_PLANET:
      	canvas.setViewMode(Planet.INNER_PLANET);
      	break;
    }
  }
}
