package planet.action;
import java.awt.Checkbox;
import java.awt.CheckboxGroup;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import planet.PlanetViewCanvas;

//--------------------------------------------------------------------//
/**
 * \[hI`FbN{bNX
 */
public class ViewModeCheckbox extends Checkbox implements ItemListener{

/** \LoX */
  protected PlanetViewCanvas canvas;

/** \[h */
  protected int mode;

/**
 * \[hI`FbN{bNX\z
 * @param canvas \LoX
 * @param label `FbN{bNX̃x
 * @param group `FbN{bNXO[v
 * @param selected ̃`FbN{bNXԂőIĂꍇ true
 * @param mode \[h
 */
  public ViewModeCheckbox(PlanetViewCanvas canvas,String label,
      	      	      	  CheckboxGroup group,boolean selected,
      	      	      	  int mode){
    super(label,group,selected);
    this.canvas=canvas;
    this.mode=mode;
    addItemListener(this);
  }

//--------------------------------------------------------------------//
/**
 * \[hI
 * @param e ANVƂCxg
 */
  public void itemStateChanged(ItemEvent e){
    canvas.setViewMode(mode);
  }
}
