package planet.calendar;
import java.util.Calendar;
import java.util.Date;

//--------------------------------------------------------------------//
/**
 * fvOpJ_[
 */
public class CalendarForPlanet{

/** EX̊_ */
  public static final double MJD_EPOCH=2400000.5;

/** 1970 N 1  1  00:00:00 GMT ̃EX */
  public static final double EPOCH_JD=2440587.5;

/** Ԃ~b֕ϊW */
  public static final double MILLIS_TO_DAY=1.0/8.64E7;

/** J_[ */
  protected Calendar calendar;

/** EX */
  protected double julianDay;

/**
 * fvOpJ_[\z
 */
  public CalendarForPlanet(){
    update();
  }

//--------------------------------------------------------------------//
/**
 * tXV
 */
  public void update(){
    calendar=Calendar.getInstance();
    julianDay=computeJulianDay(calendar);
  }

//--------------------------------------------------------------------//
/**
 * EXԂ
 * @param time 1970 N 1  1  00:00:00 GMT ̃~b
 * @return ̃EX\
 */
  public static double computeJulianDay(long time){
    return EPOCH_JD+MILLIS_TO_DAY*(double)time;
  }

//--------------------------------------------------------------------//
/**
 * EXԂ
 * @param date \ Date
 * @return ̃EX\
 */
  public static double computeJulianDay(Date date){
    return computeJulianDay(date.getTime());
  }

//--------------------------------------------------------------------//
/**
 * EXԂ
 * @param calendar \ Calendar
 * @return ̃EX\
 */
  public static double computeJulianDay(Calendar calendar){
    return computeJulianDay(calendar.getTimeInMillis());
  }

//--------------------------------------------------------------------//
/**
 * EXԂ
 * @return ̃EX\
 */
  public double getJulianDay(){
    return julianDay;
  }

//--------------------------------------------------------------------//
/**
 * EXԂ
 * @return ̃EX\
 */
  public double getModifiedJulianDay(){
    return julianDay-MJD_EPOCH;
  }

//--------------------------------------------------------------------//
/**
 * J_[Ԃ
 * @return  Calendar CX^X
 */
  public Calendar getCalendar(){
    return calendar;
  }

//--------------------------------------------------------------------//
/**
 * tԂ
 * @return  Date CX^X
 */
  public Date getDate(){
    return calendar.getTime();
  }
}
